path = require "path"
commander = require "commander"
jasminy = require "./"
terminal = require "./terminal"
paths = require "./paths"

module.exports = program = (cwd, argv) ->
    cwd = cwd ? process.cwd()
    argv = argv ? process.argv

    cmd = commander.version(jasminy.version)
    cmd.name = 'jasminy'
    cmd.option('-j, --jquery', 'Include jQuery').parse(argv)

    includes = cmd.args ? []
    includes = (path.resolve(cwd, i) for i in includes)

    cmd.emit('help') if includes.length is 0

    includes.unshift paths.jquery.default if cmd.jquery

    env = jasminy.create().
                  use(terminal()).
                  add(includes)

    env.on 'end', (runner, env) ->
        failed = runner.results().failedCount
        process.exit(1) unless failed is 0
        process.exit(0)

    env.execute()
