fs = require "fs"

exports.type = type = (value) ->
    if not value?
        value = String value
    else
        value = Object.prototype.toString.call value
        value = value.slice(0, value.length - 1)
        value = value.split(' ')[1]
        value = value.toLowerCase()
    value


exports.read = read = (path, charset, callback) ->
    if type(charset) is 'function'
        callback = charset
        charset = undefined
    charset = 'utf-8' unless charset?
    if type(callback) is 'function'
        fs.readFile path, charset, callback
    else
        return fs.readFileSync path, charset


exports.package = () ->
    JSON.parse read("#{ __dirname }/../package.json")


exports.curry = curry = (args1..., fn) ->
    throw new TypeError() unless type(fn) is 'function'
    (args2...) -> fn.apply this, args1.concat(args2)


exports.reporter = reporter = (callback) ->
    return unless type(callback) is 'function'

    reportRunnerStarting: (runner) ->
        callback 'start', runner

    reportRunnerResults: (runner) ->
        callback 'end', runner

    reportSpecStarting: (spec) ->
        callback 'spec.start', spec

    reportSpecResults: (spec) ->
        callback 'spec.end', spec

    reportSuiteResults: (suite) ->
        callback 'suite.end', suite
